# Class VulkanPipelineTessellationStateCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineTessellationStateCreateInfo

All Implemented Interfaces:
  `VulkanPipelineTessellationStateCreateInfoType`

public final class VulkanPipelineTessellationStateCreateInfo extends Object implements VulkanPipelineTessellationStateCreateInfoType
Structure specifying parameters of a newly created pipeline tessellation state.

See Also:
  - "VkPipelineTessellationStateCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineTessellationStateCreateInfo.Builder`
  Builds instances of type `VulkanPipelineTessellationStateCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineTessellationStateCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineTessellationStateCreateInfo`.
  `static VulkanPipelineTessellationStateCreateInfo`
  `copyOf(VulkanPipelineTessellationStateCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineTessellationStateCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineTessellationStateCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineTessellationStageCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `patchControlPoints`.
  `static VulkanPipelineTessellationStateCreateInfo`
  `of(Iterable<VulkanPipelineTessellationStageCreateFlag> flags, int patchControlPoints)`
  Construct a new immutable `VulkanPipelineTessellationStateCreateInfo` instance.
  `static VulkanPipelineTessellationStateCreateInfo`
  `of(Set<VulkanPipelineTessellationStageCreateFlag> flags, int patchControlPoints)`
  Construct a new immutable `VulkanPipelineTessellationStateCreateInfo` instance.
  `int`
  `patchControlPoints()`
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineTessellationStateCreateInfo` with attribute values.
  `final VulkanPipelineTessellationStateCreateInfo`
  `withFlags(VulkanPipelineTessellationStageCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineTessellationStateCreateInfo`
  `withFlags(Iterable<VulkanPipelineTessellationStageCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineTessellationStateCreateInfo`
  `withPatchControlPoints(int value)`
  Copy the current immutable object by setting a value for the `patchControlPoints` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineTessellationStageCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineTessellationStateCreateInfoType`
    Returns:
      Creation flags

  - ### patchControlPoints

    public int patchControlPoints()
    Specified by:
      `patchControlPoints` in interface `VulkanPipelineTessellationStateCreateInfoType`
    Returns:
      The number of control points per patch.

  - ### withFlags

    public final VulkanPipelineTessellationStateCreateInfo withFlags(VulkanPipelineTessellationStageCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineTessellationStateCreateInfo withFlags(Iterable<VulkanPipelineTessellationStageCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withPatchControlPoints

    public final VulkanPipelineTessellationStateCreateInfo withPatchControlPoints(int value)
    Copy the current immutable object by setting a value for the `patchControlPoints` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for patchControlPoints
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineTessellationStateCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `patchControlPoints`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineTessellationStateCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineTessellationStateCreateInfo of(Set<VulkanPipelineTessellationStageCreateFlag> flags, int patchControlPoints)
    Construct a new immutable `VulkanPipelineTessellationStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `patchControlPoints` - The value for the `patchControlPoints` attribute
    Returns:
      An immutable VulkanPipelineTessellationStateCreateInfo instance

  - ### of

    public static VulkanPipelineTessellationStateCreateInfo of(Iterable<VulkanPipelineTessellationStageCreateFlag> flags, int patchControlPoints)
    Construct a new immutable `VulkanPipelineTessellationStateCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `patchControlPoints` - The value for the `patchControlPoints` attribute
    Returns:
      An immutable VulkanPipelineTessellationStateCreateInfo instance

  - ### copyOf

    public static VulkanPipelineTessellationStateCreateInfo copyOf(VulkanPipelineTessellationStateCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineTessellationStateCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineTessellationStateCreateInfo instance

  - ### builder

    public static VulkanPipelineTessellationStateCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineTessellationStateCreateInfo`.

         VulkanPipelineTessellationStateCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineTessellationStageCreateFlag) // flags elements
            .setPatchControlPoints(int) // required patchControlPoints
            .build();

    Returns:
      A new VulkanPipelineTessellationStateCreateInfo builder